#!/bin/bash

##### Beginning of file

set -ev

# export COMPILED_MODULES="$1"
echo "COMPILED_MODULES=$COMPILED_MODULES"

export JULIA_FLAGS="--check-bounds=yes --code-coverage=all --color=yes --compiled-modules=$COMPILED_MODULES --inline=no"
echo "JULIA_FLAGS=$JULIA_FLAGS"

export INSTALL_GIT="true"
export INSTALL_GITLFS="true"
echo "INSTALL_GIT=$INSTALL_GIT"
echo "INSTALL_GITLFS=$INSTALL_GITLFS"

julia $JULIA_FLAGS -e 'import Pkg; Pkg.build("RepoSnapshots");'
julia $JULIA_FLAGS -e 'import RepoSnapshots;'
julia $JULIA_FLAGS -e 'import Pkg; Pkg.test("RepoSnapshots"; coverage=true);'

cat Project.toml
cat Manifest.toml

julia $JULIA_FLAGS -e 'import Pkg; try Pkg.add("Coverage") catch end;'
julia $JULIA_FLAGS ci/travis/codecov-catch-errors.jl

##### End of file
